import Head from 'next/head'
import Image from 'next/image'
import { Inter } from '@next/font/google'
import styles from '../styles/Home.module.css'
import News from '../components/news'
import axios from "axios";
import HOST from "../config/config"
import { useEffect, useState } from 'react'
import Container from 'react-bootstrap/Container';
import Row from 'react-bootstrap/Row';
import Col from 'react-bootstrap/Col';
import InfiniteScroll from 'react-infinite-scroll-component';
import Navbar from "../components/Navbar";
import 'bootstrap/dist/css/bootstrap.css';


const inter = Inter({ subsets: ['latin'] })

export default function Home() {
  const [data, setData] = useState([])
  const [totalPages, setTotal] = useState(1)
  const [current, setCurrent] = useState(1)
  const [hasMore, setHasMore] = useState(true)
  const [categoryHeading, setHeading] = useState("All")
  const [cat1, setCat1] = useState(false);
  const [cat2, setCat2] = useState(false);
  const [cat3, setCat3] = useState(false);
  const [cat4, setCat4] = useState(false);
  const [cat5, setCat5] = useState(false);
  const [cat6, setCat6] = useState(false);
  const [cat7, setCat7] = useState(false);
  const [cat8, setCat8] = useState(false);

  const toggleClass = (category) => {
    if (category == "cat1") {
      setCat1(true);
      setCat2(false);
      setCat3(false);
      setCat4(false);
      setCat5(false);
      setCat6(false);
      setCat7(false);
      setCat8(false);
    }

    if (category == "cat2") {
      setCat1(false);
      setCat2(true);
      setCat3(false);
      setCat4(false);
      setCat5(false);
      setCat6(false);
      setCat7(false);
      setCat8(false);
    }

    if (category == "cat3") {
      setCat1(false);
      setCat2(false);
      setCat3(true);
      setCat4(false);
      setCat5(false);
      setCat6(false);
      setCat7(false);
      setCat8(false);
    }

    if (category == "cat4") {
      setCat1(false);
      setCat2(false);
      setCat3(false);
      setCat4(true);
      setCat5(false);
      setCat6(false);
      setCat7(false);
      setCat8(false);
    }

    if (category == "cat5") {
      setCat1(false);
      setCat2(false);
      setCat3(false);
      setCat4(false);
      setCat5(true);
      setCat6(false);
      setCat7(false);
      setCat8(false);
    }

    if (category == "cat6") {
      setCat1(false);
      setCat2(false);
      setCat3(false);
      setCat4(false);
      setCat5(false);
      setCat6(true);
      setCat7(false);
      setCat8(false);
    }

    if (category == "cat7") {
      setCat1(false);
      setCat2(false);
      setCat3(false);
      setCat4(false);
      setCat5(false);
      setCat6(false);
      setCat7(true);
      setCat8(false);
    }

    if (category == "cat8") {
      setCat1(false);
      setCat2(false);
      setCat3(false);
      setCat4(false);
      setCat5(false);
      setCat6(false);
      setCat7(false);
      setCat8(true);
    }
  };

  const getMorePosts = () => {
    if (current + 1 <= totalPages) {
      axios.get(HOST + `/blogs?populate=*&pagination[page]=${current + 1}&pagination[pageSize]=4`).then(resp => {
        console.log(data)
        console.log(resp.data.data)
        setData([...data, ...resp.data.data])
        setCurrent(current + 1)
      })
    } else {
      setHasMore(false)
      setCurrent(current + 1)
    }
  }

  const fetchCategory = (id, heading) => {
    setHeading(heading)
    axios.get(HOST + `/blogs?populate=*&filters[categories][id][$eq]=${id}`).then(resp => {
      console.log(resp.data.data)
      setData(resp.data.data);
    })
  }

  useEffect(() => {
    axios.get(HOST + "/blogs?populate=*&pagination[page]=1&pagination[pageSize]=4").then(resp => {
      setData(resp.data.data);
      setTotal(resp.data.meta.pagination.pageCount)
    })
  }, [])

  return (
    <>
      <Head>
        <title>PBT India | Home</title>
        <meta name="description" content="Generated by create next app" />
        <meta name="viewport" content="width=device-width, initial-scale=1" />
        <link rel="icon" href="/favicon.ico" />
      </Head>
      <Navbar />
      <main>
        <div className="container mt-5">
          <div className="row">
            <div className="col-md-8">
              Showing Results for: {categoryHeading} <br /><br />
              <InfiniteScroll
                dataLength={data.length}
                next={getMorePosts}
                hasMore={hasMore}
                loader={<h4>Loading ...</h4>}
                endMessage={<h5>No Results to show</h5>}>
                {data.map(blog => {
                  return (<News title={blog.attributes.title} id={blog.id} description={blog.attributes.desc} dated={blog.attributes.dated} key={blog.id} press={blog.attributes.press_release} />)
                })}
              </InfiniteScroll>
            </div>
            <div className="col-md-4">
              <ul className="list-group">
                <li className="list-group-item category-title">Explore by Category<hr /></li>
                <li className={"list-group-item " + (cat1 ? 'show' : '')} onClick={() => { toggleClass("cat1"), fetchCategory(1, "Anuradha Saha's Case") }}>Anuradha Saha's Case</li>
                <li className={"list-group-item " + (cat2 ? 'show' : '')} onClick={() => { toggleClass("cat2"), fetchCategory(2, "Judicial Corruption") }}>Judicial Corruption</li>
                <li className={"list-group-item " + (cat3 ? 'show' : '')} onClick={() => { toggleClass("cat3"), fetchCategory(3, "Medical Council of India") }}>Medical Council of India</li>
                <li className={"list-group-item " + (cat4 ? 'show' : '')} onClick={() => { toggleClass("cat4"), fetchCategory(4, "Medical Negligence") }}>Medical Negligence</li>
                <li className={"list-group-item " + (cat5 ? 'show' : '')} onClick={() => { toggleClass("cat5"), fetchCategory(5, "PBT") }}>PBT</li>
                <li className={"list-group-item " + (cat6 ? 'show' : '')} onClick={() => { toggleClass("cat6"), fetchCategory(6, "Public Interest Litigation") }}>Public Interest Litigation</li>
                <li className={"list-group-item " + (cat7 ? 'show' : '')} onClick={() => { toggleClass("cat7"), fetchCategory(7, "State Medical Councils") }}>State Medical Councils</li>
                <li className={"list-group-item " + (cat8 ? 'show' : '')} onClick={() => { toggleClass("cat8"), fetchCategory(8, "Supreme Court") }}>Supreme Court</li>
              </ul>
            </div>
          </div>
        </div>
      </main>
    </>
  )
}
